#pragma once
//#if _MSC_VER >=1600  // MSVC2015>1899, msvc_ver=14.0
//#pragma execution_character_set("utf-8")
//#endif
//#include "qtclasslibrary1_global.h"
#include <qstring.h>
#include <QtPlugin>
#include <QVector>
#include <QObject>

struct SPluginMetaData
{
	QVector<QString> qvsReturnFilePaths;
	QVector<QString> qvsSendFilePaths;
	bool isAdd2Map;

};
class  SrsMainInterface : public QObject
{
	Q_OBJECT
public:
	virtual ~SrsMainInterface() {}

	/// <summary>
	/// pannel
	/// </summary>
	virtual QString PannelName() = 0;

	/// <summary>
	/// Category
	/// </summary>
	/// <returns></returns>
	virtual QString CategoryName() = 0;

	/// <summary>
	/// زӢ
	/// </summary>
	/// <returns></returns>
	virtual QString EnglishName() = 0;
	/// <summary>
	/// ز
	/// </summary>
	/// <returns></returns>
	virtual QString ChineseName() = 0;
	virtual QString Information() = 0;
	virtual QString IconPath() = 0;
	virtual QWidget* CenterWidget() = 0;
	//
	//public slots:
	//	virtual void test(QWidget* parent) = 0;

signals:
	void AddDataToMap(QStringList string_list);
	//void addDataToCanvas(QStringList string_list);
};

#define MainInterface_iid "com.Srs.MainInterface"
Q_DECLARE_INTERFACE(SrsMainInterface, MainInterface_iid)
